package com.trs.ggzyexchange.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.entity.OtherTradePubInfo;
import com.trs.ggzyexchange.entity.OtherTradeResultInfo;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.OtherTradePubInfoService;
import com.trs.ggzyexchange.service.OtherTradeResultInfoService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-10-19
 */
@RestController
@RequestMapping("/other-trade-result-info")
public class OtherTradeResultInfoController extends BaseController {
    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private OtherTradeResultInfoService otherTradeResultInfoService;

    //@GetMapping(value = "/queryTradeResultInfoEs")
    public Integer queryTradeResultInfoEs() throws JsonProcessingException {
        int count = otherTradeResultInfoService.count();
        Integer pageSize = 1000;
        Integer pageNum = (int)Math.ceil((double)count/pageSize);
        List<TenderDetailsVo> tenderDetailsVosList = new ArrayList<TenderDetailsVo>();
        for(int i = 1; i <= pageNum;i++){
            QueryWrapper<OtherTradeResultInfo> queryWrapper = new QueryWrapper<OtherTradeResultInfo>();
            Page<OtherTradeResultInfo> page = new Page<OtherTradeResultInfo>(i, pageSize);
            IPage<OtherTradeResultInfo> pageList = otherTradeResultInfoService.page(page, queryWrapper);
            List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
            for (OtherTradeResultInfo otherTradeResultInfo : pageList.getRecords()) {
                TenderDetailsVo tenderDetailsVo = new TenderDetailsVo();
                tenderDetailsVo.setSourceDataKey(otherTradeResultInfo.getGuid());
                tenderDetailsVo.setProjectCode(otherTradeResultInfo.getProjectCode());
                tenderDetailsVo.setProjectName(otherTradeResultInfo.getProjectName());
                tenderDetailsVo.setTenderProjectCode(otherTradeResultInfo.getProjectCode());
                tenderDetailsVo.setNoticeName(otherTradeResultInfo.getAnnouncementTitle());
                tenderDetailsVo.setNoticeContent(otherTradeResultInfo.getAnnouncementConnect());
                tenderDetailsVo.setNoticeSendTime(otherTradeResultInfo.getPublishingTime());
                tenderDetailsVo.setNoticeTypeCode(ClassIfy.OTHER_TRANSACTION_RESULTS.getCode());
                tenderDetailsVo.setNoticeTypeName(ClassIfy.OTHER_TRANSACTION_RESULTS.getName());
                tenderDetailsVo.setTransactionTypeCode(ClassIfy.OTHER_TRANSACTIONS.getCode());
                tenderDetailsVo.setTransactionTypeName(ClassIfy.OTHER_TRANSACTIONS.getName());
                tenderDetailsVo.setRegionCode(otherTradeResultInfo.getCode());
                tenderDetailsVo.setRegionName(otherTradeResultInfo.getCodePram());
                tenderDetailsVo.setDataSourceCode(otherTradeResultInfo.getJyptid());
                tenderDetailsVo.setPlatformCode(otherTradeResultInfo.getPlatformCode());
                tenderDetailsVos.add(tenderDetailsVo);
                TenderDetailsVoUtils.isNull(tenderDetailsVo);
            }
            tenderDetailsVosList = tenderDetailsVos;
            Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVos);
        }
        return tenderDetailsVosList.size();
    }
}
